package com.izouma.dingdong.web.backstage;

import com.izouma.dingdong.web.BaseController;
import com.izouma.dingdong.domain.backstage.Voice;
import com.izouma.dingdong.service.backstage.VoiceService;
import com.izouma.dingdong.dto.PageQuery;
import com.izouma.dingdong.exception.BusinessException;
import com.izouma.dingdong.repo.backstage.VoiceRepo;
import com.izouma.dingdong.utils.ObjUtils;
import com.izouma.dingdong.utils.excel.ExcelUtils;

import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/voice")
@AllArgsConstructor
public class VoiceController extends BaseController {
    private VoiceService voiceService;
    private VoiceRepo voiceRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public Voice save(@RequestBody Voice record) {
        if (record.getId() != null) {
            Voice orig = voiceRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return voiceRepo.save(orig);
        }
        return voiceRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @GetMapping("/all")
    public Page<Voice> all(PageQuery pageQuery) {
        return voiceRepo.findAll(toSpecification(pageQuery,Voice.class), toPageRequest(pageQuery));
    }

    @GetMapping("/get/{id}")
    public Voice get(@PathVariable Long id) {
        return voiceRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        voiceRepo.deleteById(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<Voice> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }
}

